clear;
clc;

global section_num;
global sl;
global gd;
global subsection_length;
global total_running_time;
global current_speed;
global subsection_list;

TolX_val=1e-14;
TolCon_val=1e-10;
TolFun_val=1e-10;
MaxIter_val=4000;
MaxFunEvals_val=2000000;

train_network_yizhuang

subsection_list=[	   0     150    -0.002	13.89
					 150     160    -0.002	23.61
					 160     470    -0.003	23.61
					 470     480     0.0104	23.61
					 480     970     0.0104	18.06
					 970    1161	 0.003	18.06
					1161	1370 	 0.003	23.61
					1370	1880	-0.008	23.61
					1880	2500	 0.003	23.61
					2500	2501	-0.002	23.61
					2501	2643	-0.002	16.67
					2643	2770	-0.002	23.61
					2770	2797	-0.003	23.61
					2797	3170	-0.003	20.83
					3170	3534	 0.0082	20.83
					3534	3570	 0.0082	23.61
					3570	3780	 0.002	23.61
					3780	3918	 0.002	16.67
					3918	3940	 0.002	23.61
					3940	4200	-0.0204	23.61
					4200	4800	-0.024	23.61
					4800	5200	 0      23.61
					5200	5800	-0.002	23.61
					5800	5808	-0.0032	23.61
					5808	6050	-0.0032	20.83
					6050	6141	 0      20.83
					6141	6271	 0      16.67];

section_num=size(subsection_list,1);
sl=subsection_list(:,4)';
gd=subsection_list(:,3)';
subsection_length=[subsection_list(:,2)-subsection_list(:,1)]';
total_running_time=370;
current_speed = 0;
min_sub_running_time=subsection_length./sl;

global a_r  b_r  c_r  a_max  a_min;
a_r=1.0393/10^4;
b_r=0;
c_r=0.0142;
a_max=310/278;
a_min=260/278;

nvars=7*section_num;
LB=zeros(7*section_num,1);
UB=zeros(7*section_num,1);
for i=1:section_num
    UB(7*(i-1)+[1:4])=total_running_time-sum(min_sub_running_time)+min_sub_running_time(i);
    UB(7*(i-1)+[5:6])=sl(i);
    if i~=section_num
        UB(7*i)=min(sl(i), sl(i+1));
    else
        UB(7*i)=0;
    end;
end;
Aeq=repmat([ones(1,4), zeros(1,3)], 1, section_num);
beq=total_running_time;

trial_num=100; % number of trials
energy_consumption=zeros(trial_num,1);
opt_result=zeros(trial_num, section_num*7);
for xxx=1:trial_num
    xxx;
    x0=zeros(1,nvars);
    
    x0_t=rand(1, section_num);
    x0_t=min_sub_running_time+x0_t./sum(x0_t)*(total_running_time-sum(min_sub_running_time));
    x0_t_temp=x0_t;
    for i=1:section_num
        rand_temp=rand(1,4);
        x0_t(1,4*(i-1)+[1:4])=rand_temp./sum(rand_temp)*x0_t_temp(i);
    end;
    
    for i=1:section_num
        x0(1,(i-1)*7+[1:4])=x0_t((i-1)*4+[1:4]); % total_running_time/(section_num*4);
        x0(1,(i-1)*7+[5:6])=sl(i)*rand(1);
        if i~=section_num
            x0(1,(i-1)*7+7)=min(sl(i:i+1))*rand(1);
        else
            x0(1,(i-1)*7+7)=0;
        end;
    end;

    %% fmincon
    options_0=optimoptions('fmincon','Algorithm', 'interior-point', 'SubproblemAlgorithm', 'factorization', 'Display', 'notify', 'TolX', TolX_val, 'TolCon', TolCon_val, 'TolFun', TolFun_val, 'MaxIter', MaxIter_val, 'MaxFunEvals', MaxFunEvals_val);
    options_opt = optimoptions('fmincon','Algorithm', 'interior-point', 'SubproblemAlgorithm', 'cg', 'Display', 'notify', 'TolX', TolX_val, 'TolCon', TolCon_val, 'TolFun', TolFun_val, 'MaxIter', MaxIter_val, 'MaxFunEvals', MaxFunEvals_val);

    tic
    [x1,E1,exitflag,~] = fmincon(@(x)0,x0,[],[],Aeq,beq,LB,UB,@nonlcon_braking_curve_analytic,options_0);
    total_time_0(xxx,1)=toc;
    exit_flag_0(xxx,1)=exitflag;
    tic
    [x2,E2,exitflag,~] = fmincon(@energy_consumption_analytic,x1,[],[],Aeq,beq,LB,UB,@nonlcon_braking_curve_analytic,options_opt);
    total_time_opt(xxx,1)=toc;
    exit_flag_opt(xxx,1)=exitflag;
    total_time(xxx,1)=total_time_0(xxx,1)+total_time_opt(xxx,1);
    output=[x1; x2];
    E(xxx,:)=[E1,E2];
    energy_consumption(xxx)=E2;
    opt_result(xxx,:)=x2;
end;
yyy=find(exit_flag_opt==2);
trial_num-length(yyy)
[max(total_time(yyy)), mean(total_time(yyy)), min(total_time(yyy))]
[max(energy_consumption(yyy)), mean(energy_consumption(yyy)), min(energy_consumption(yyy))]
exit_flag_opt(find(exit_flag_opt~=2))'
save method_1_original.mat

temp_figure;