function [c,ceq] = nonlcon_braking_curve_analytic_rem(x, operation_kept_tag)

global section_num;
global current_speed;
global gd;
global subsection_length;
global a_r  b_r  c_r  a_max  a_min;

x_new=zeros(1,7*section_num);
x_new(find(operation_kept_tag==1))=x;
x=x_new;

t_a = x(7*[1:section_num]-6);
t_s = x(7*[1:section_num]-5);
t_c = x(7*[1:section_num]-4);
t_b = x(7*[1:section_num]-3);
v_a = x(7*[1:section_num]-2);
v_b = x(7*[1:section_num]-1);
v_f = x(7*[1:section_num]);
v_0 = [current_speed, v_f(1:section_num-1)]; 

for i=1:section_num
    if ~operation_kept_tag(7*(i-1)+1)
        v_a(i)=v_0(i);
    end;
    if ~operation_kept_tag(7*(i-1)+3)
        v_b(i)=v_a(i);
    end;
    if ~operation_kept_tag(7*(i-1)+4)
        v_0(i+1)=v_b(i);
    end;
end;

c=zeros(2*section_num,1);
ceq=zeros(6*section_num,1);
for i=1:section_num
    %% max traction
    if operation_kept_tag(7*(i-1)+1)
        [s_a,v_a_temp] = solve_ode_piecewise(-a_r,-b_r,a_max-c_r-9.80665*(gd(i)),-a_r,-b_r-18/278,490/278-c_r-9.80665*(gd(i)),t_a(i),v_0(i),10);
    else
        s_a=0;
        v_a_temp=v_a(i);
    end;

    %% speedholding
    s_s=v_a(i)*t_s(i);
    
    %% coasting
    if operation_kept_tag(7*(i-1)+3)
        [s_c,v_b_temp] = solve_ode(-a_r,-b_r,0-c_r-9.80665*(gd(i)), t_c(i), v_a(i));
    else
        s_c=0;
        v_b_temp=v_b(i);
    end;
    %% max braking
    if operation_kept_tag(7*(i-1)+4)
    [s_b,v_f_temp] = solve_ode_piecewise(-a_r,-b_r,-a_min-c_r-9.80665*(gd(i)),-a_r,-b_r+18/278,-560/278-c_r-9.80665*(gd(i)), t_b(i), v_b(i),50/3); 
    else
        s_b=0;
        v_f_temp=v_f(i);
    end;
    
    %% nonlinear constraints
    ceq(4*(i-1)+[1:4])=[v_a_temp-v_a(i); v_b_temp-v_b(i); v_f_temp-v_f(i); s_a+s_s+s_c+s_b-subsection_length(i)];
    c(2*(i-1)+[1:2])=[-t_s(i)*(a_r*v_a(i)^2+b_r*v_a(i)+c_r+9.80665*gd(i)+min(260,260-5*(3.6*v_a(i)-60))/278), t_s(i) * (a_r*v_a(i)^2+b_r*v_a(i)+c_r+9.80665*gd(i)-min(310,310-5*(3.6*v_a(i)-36))/278)];
end;